<xsl:stylesheet version="1.0"  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                  xmlns:xs="http://www.w3.org/2001/XMLSchema">

<!-- variables -->
<xsl:variable name="CHAR_SPC">&#160;</xsl:variable>

<xsl:template match="/">

<html>

<head> 
<title>automation-beyond.com | TestLog XML/XSL Transformation Example by Albert Gareev</title> 
</head>

<body bgcolor="#c0c0c0">

<H1 align="center">Test Log</H1>
<H4 align="center">XML/XSL Transformation Example by <A HREF="http://automation-beyond.com/about/">Albert Gareev</A></H4>
<BR />
<P />
<h3 align="center">Test Steps</h3>
<BR />
<TABLE id="automation-beyond-2010" BORDER="1" width="650" align="center">
<TR> 
  <TH width="150">Step Name</TH>
  <TH width="500">Step Description</TH>
</TR>

<xsl:for-each select="log/step"> 
  <xsl:choose>

    <xsl:when test = " @type = '#note' ">
      <xsl:call-template name="Display_Note" />
    </xsl:when>

    <xsl:when test = " @type = '#idea' ">
      <xsl:call-template name="Display_Idea" />
    </xsl:when>

    <xsl:when test = " @type = '#bug' ">
      <xsl:call-template name="Display_Bug" />
    </xsl:when>

    <xsl:otherwise>
      <TR>
        <TD>Error</TD>
        <TD>XML data error</TD> 
     </TR>
    </xsl:otherwise>

  </xsl:choose> 
</xsl:for-each>
</TABLE>
<BR />
<BR />
<BR />
<BR />

<div align="center">
<A HREF="http://automation-beyond.com/chapters/tutorials/test-reports/">Home</A>
</div>
<BR />

</body>

</html>
</xsl:template>

<!-- **************Sub-Templates****************************************** -->

<!-- **************Test Note****************************************** -->
<xsl:template name="Display_Note">
  <TR>
      <TD>
        <xsl:attribute name="title"><xsl:value-of select = "time" /></xsl:attribute>
        Test Note
      </TD>
      <TD><xsl:value-of select = "description" /><xsl:value-of select = "$CHAR_SPC" /></TD> 
  </TR>
</xsl:template>

<!-- **************Test Idea****************************************** -->
<xsl:template name="Display_Idea">
  <TR>
      <TD>
        <xsl:attribute name="title"><xsl:value-of select = "time" /></xsl:attribute>
        Test Idea
      </TD>
      <TD><xsl:value-of select = "description" /><xsl:value-of select = "$CHAR_SPC" /></TD> 
  </TR>
</xsl:template>

<!-- **************Logged Bug****************************************** -->
<xsl:template name="Display_Bug">
  <TR>
      <TD>
        <xsl:attribute name="title"><xsl:value-of select = "time" /></xsl:attribute>
        Bug
      </TD>

      <xsl:choose> 
        <xsl:when test=" flags/@screenshot = 'YES' ">
          <TD>
 	      <xsl:attribute name="title">Click on the link to view the image attached</xsl:attribute>
	      <A TARGET="_blank">
		  <xsl:attribute name="href"> 
		    <xsl:value-of select="screenshot" /> 
		  </xsl:attribute> 
              <xsl:value-of select = "description" />
  	      </A> 
          </TD> 
        </xsl:when> 

        <xsl:otherwise>
          <TD><xsl:value-of select = "description" /><xsl:value-of select = "$CHAR_SPC" /></TD> 
        </xsl:otherwise> 
      </xsl:choose> 

  </TR>
</xsl:template>

</xsl:stylesheet>
